#!/usr/bin/perl

$zalgaller=$ARGV[0];
open (ZALGALLER,"<$zalgaller") || die "Can't open file $zalgaller\n";

$i=0;
while(<ZALGALLER>){
chop;
$tmp[$i]=$_;
$i++;
}
close(ZALGALLER);

$lines=0;
$numof_vertex=$tmp[$lines];

$lines=$lines+$numof_vertex+$numof_vertex+2;
$numof_faces=$tmp[$lines];
$numof_edges = $numof_faces + $numof_vertex - 2; ## by Euler's theorem

$j=0;
$lines++;
for($i=$lines;$i<$lines+$numof_faces;$i++){
 $num=split(' ',$tmp[$i]);
 for($k=0;$k<$num;$k++){$face_list[$j][$k]=@_[$k];}
 $j++;
}

$lines=$lines+$numof_faces+1;
$j=0;
for($i=$lines;$i<$lines+$numof_vertex+1;$i++){
 $num=split(' ',$tmp[$i]);
 for($k=0;$k<$num;$k++){$vertex_coordinates[$j][$k]=@_[$k];}
 $j++;
}

$zalgaller_obj="obj$zalgaller" . ".h";
open(ZALGALLER,">$zalgaller_obj") || die "Can't open file $zalgaller_obj\n";

$i=0;
print ZALGALLER "/* $zalgaller_obj - structure values for $zalgaller */\n\n";
print ZALGALLER "{	\"$zalgaller\", \"$zalgaller\",		/* long and short names */\n";
print ZALGALLER "	\"NONE\",			/* long name of dual */\n";
printf (ZALGALLER "	%3d,%3d,%3d,		/* number of vertices, edges, and faces */\n", $numof_vertex, $numof_edges, $numof_faces);
print ZALGALLER "	{			/* vertices (x,y,z) */\n";
print ZALGALLER "				/* all points must be within radius 1 of the origin */\n";

for($i=0;$i<$numof_vertex-1;$i++){
  printf(ZALGALLER "		{%11.8lf, %11.8lf, %11.8lf},\n",$vertex_coordinates[$i][1]
						 ,$vertex_coordinates[$i][2]
						 ,$vertex_coordinates[$i][3]);
}
$i=$numof_vertex-1;
printf(ZALGALLER "		{%11.8lf, %11.8lf, %11.8lf}\n",$vertex_coordinates[$i][1]
						 ,$vertex_coordinates[$i][2]
						 ,$vertex_coordinates[$i][3]);
print ZALGALLER "	},\n";
print ZALGALLER "	{	/* faces (numfaces + indexes into vertices) */\n";
print ZALGALLER "		/*  faces must be specified clockwise from the outside */\n";

for($i=0;$i<$numof_faces;$i++){
  $k=$face_list[$i][1];
    printf (ZALGALLER "		%2d,   ",$face_list[$i][1]);
    for($j=2;$j<$k+2;$j++){
      printf (ZALGALLER "%3d",$face_list[$i][$j]-1);
	if (($i!=$numof_faces-1) || ($j != $k+1)) {print ZALGALLER ",";}
    }
   print ZALGALLER "\n";
}
print ZALGALLER "	}\n";
print ZALGALLER "},		/* leave a comma to separate from the next include file */\n";
print ZALGALLER "/* end */\n";

close(ZALGALLER);
exit;
###################################################
print "Number of faces $numof_faces\n";
print "Number of edges $numof_edges\n";
print "Number of vertex $numof_vertex\n";

print "Vertex index list\n";
for($i=0;$i<$numof_faces;$i++){
  $k=$face_list[$i][1];
    for($j=2;$j<$k+2;$j++){
      print "$face_list[$i][$j] ";
    }
   print "\n";
}

print "Vertex coordinate list\n";
for($i=0;$i<$numof_vertex;$i++){
    for($j=1;$j<4;$j++){
      print "$vertex_coordinates[$i][$j] ";
    }
   print "\n";
}
